(function(context) {

    var communication = function(destination, service) {
        var that = {};

        that.destination = destination;
        that.service     = service;

        return that;
    };



    var service = function(spec) {
        var that = {};

        spec = spec || {};
        that.domain = spec.domain || 'unknown';
        that.policy = spec.policy || defaultPolicy();
        that.handleMessage = spec.handleMessage || function() {};

        function defaultPolicy() {
            return policy('restricted');
        }

        return that;
    };

    var policy = function(spec) {
        var that = {};

        spec = spec || {};
        that.restriction = spec.restriction || 'restricted';
        
        return that;
    };

    // Fake services. 
    // TODO: add service registration to the API
    var services = [
        ['io', 'restricted', function(o, e) {console.log('io: ' + e.data.message)}], 
        ['dom', 'restricted'], 
        ['default', 'permissive']
    ].map(function(each) {
        return service({domain: each[0], policy: policy({restriction: each[1]}), handleMessage: each[2]});
    });

    // TODO:
    // We probably shouldn't expost all this.
    // Only service registration should be made public.
    // Services themselves should be private
    context.sandbox = {
        service:       service,
        policy:        policy,
        services:      services,
        communication: communication
    };

})(this)
